/*** prostat 1.32 ***/

/*** sscanf.c; functions to replace sscanf(), which is far too slow, in
     certain specific cases ***/

#include "analhead2.h"

char *tabmon[12] = {"Jan","Fev","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};

/*** First a routine to check if we want to read in the arguments for a
  given filename ***/

flag expandq(char *filename)
{
  extern struct stringlist *expandhead, *noexpandhead;
  extern struct wstringlist *wexpandhead, *wnoexpandhead;

  struct stringlist *stringp;
  struct wstringlist *wstringp;

  /* if it matches any of the WITHOUTARGs, throw it out straight away */

  for (stringp = noexpandhead; stringp -> name[0] != '\0';
       stringp = stringp -> next) {
    if (strcmp(filename, stringp -> name) == 0)
      return(FALSE);
  }

  for (wstringp = wnoexpandhead; wstringp -> length != -1;
       wstringp = wstringp -> next) {
    if (strncmp(filename, wstringp -> name,
		(size_t)(wstringp -> length)) == 0)
      return(FALSE);
  }

  /* otherwise, it has to match one of the WITHARGs */

  for (stringp = expandhead; stringp -> name[0] != '\0';
       stringp = stringp -> next) {
    if (strcmp(filename, stringp -> name) == 0)
      return(TRUE);
  }

  for (wstringp = wexpandhead; wstringp -> length != -1;
       wstringp = wstringp -> next) {
    if (strncmp(filename, wstringp -> name,
		(size_t)(wstringp -> length)) == 0)
      return(TRUE);
  }

  /* if it doesn't match any of them, we don't want it */

  return(FALSE);

}

char *monchar(int mon)
{

	return(tabmon[mon]);

}

int parse_url(char *url, char *protocole, char *host, int *port, char *path)
{
        char *p;
        int i, j, finhost;
        size_t len;
	char *cin = url;
        char *cout;

	i = 0;
        for (cout = protocole; *cin != ':' && *cin != '\n' && *cin != '\0' && i
< 16; cin++) {
                *cout = *cin;
                cout++;
                i++;
        }

        *cout = '\0';

        /* patch Bruno PENNEC v0.1 */
        /* erreur dans la definition du proto */

        if(strncmp(cin, "://",3)){
	  strcpy(protocole,"http");
          cin = url;
	}
	else {
	  cin++;cin++;cin++;
	}

        i = 0;

        p = strchr(url, '@');
	/* cin est positionner apres <proto>://  ....           */
        /*  attention ... il peut y avoir un @ dans le path     */
        if(p != NULL)
        {                                                       /* CRI */
                char *pp;                                       /* CRI */
                pp = strchr(cin,'/');                           /* CRI */
                if ((pp != NULL) && (pp > p)) cin = p+1;        /* CRI */
                /*  else the '@' is part of the path               CRI */
        }


        j=0;
        finhost=0;
        len = strlen(cin);
        for(i=0; i<len && j < MAXSTRINGLENGTH - 1; i++) {
                if (finhost == 0) {
                        if(cin[i] == '/') {
                                finhost=1;
                                host[j]='\0';
                                path[0]='/';
                                j=1;
                        }
                        else
                        {
                                host[j]=cin[i];
                                j++;
                        }
                }
                else
                {
                        path[j]=cin[i];
                        j++;
                }
        }
        if(finhost==0) {
                host[j]='\0';
                sprintf(path,"/");
        }
        else {
                path[j]='\0';
        }
        if (p = strstr(host, ":")) {
                sscanf(p+1,"%d",port);
                *p='\0';
        }
        else {
                *port=80;
        }
        fflush(stdout);
        return(1);

}

int *scan_url(char *path, char *filetype)
{
	size_t len;
	char *suffixe;

	strcpy(filetype, "\0");
	if (path[0] == '\0') {
		sprintf(filetype, "/");
	}
	else {
		len = strlen(path);
		if(path[len-1] == '/') {
			sprintf(filetype, "/");
		}
		else {
		  suffixe = strrchr(path, '/') + 1;

		  suffixe = strrchr(suffixe, '.');
		  if(suffixe != NULL) {
			suffixe++;
			if(strlen(suffixe) < 10) { /* 10 = long of filetype */
			 strcpy(filetype, suffixe);
			}
			else
			  strcpy(filetype, "\0");
		  }
		}
        }


        return(0);

}

int is_it_a_hit(char *tag)
{

	if ((strstr(tag, "HIT") != NULL && strstr(tag, "UDP_HIT") == NULL) || strstr(tag, "UDP_HIT_OBJ") != NULL) {
		return(1);
	}
	return(0); 

}


/*** Now the scanning routines ***/

int sscan_line(char *inputline, char hostn[MAXSTRINGLENGTH], flag *is_an_alias, int *date,
		  char month[4], int *year, int *hr, int *min,
		  char rhost[MAXSTRINGLENGTH], int *code, char tag[MAXSTRINGLENGTH], char bytestr[16], 
		  char protocole[MAXSTRINGLENGTH], char method[15], char filetype[10],
		  char tag2[MAXSTRINGLENGTH], char neighbour[MAXSTRINGLENGTH], int *elapse_time)
{
  extern struct tm *localtime();
  extern flag debug;
  extern flag doaliashost();

  register char *cin = inputline;   /* the character we are reading */
  register char *cout;              /* where we are putting it */
  char time_sec[14];
  time_t t;
  char c[100];
  char url[MAXURL];
  char elapse[10];
  int i;
  int port;
  struct tm *D;
  char remote_host[MAXSTRINGLENGTH];
  char path[MAXURL];
  
  /* read in date */
  i = 0;
  for (cout = time_sec; *cin != '.' && *cin != '\n' && *cin != '\0' && i < 13;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }

  if (*cin != '.')
    return(1);
  *cout = '\0';
  sscanf(time_sec, "%d", &t);
  D = localtime(&t);
  *date = D->tm_mday;
  sprintf(month, "%s", monchar(D->tm_mon));
  *year = D->tm_year;
  *year += 1900;
  *hr = D->tm_hour;
  *min = D->tm_min;

if(debug)
	fprintf(stderr, "Date : %d %s %d : %d:%d\n", *date, month, *year, *hr, *min);

  cin++;cin++;cin++;cin++;

  /* scan until next char */
  for (cin++; *cin == ' '; cin++)
    ;
  if (*cin == '\0')
    return(2);

  /* read in elapse */
  i = 0;
  for (cout = elapse; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 9;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  if (*cin != ' ')
	return(2);
  *cout = '\0';
  *elapse_time = atoi(elapse);

if(debug)
        fprintf(stderr, "elapse : %s\n", elapse);
  
  /* read in hostn */
  cin++;
  i = 0;
  for (cout = hostn; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < MAXSTRINGLENGTH - 1;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';

  *is_an_alias = doaliashost(hostn);

if(debug)
	fprintf(stderr, "hostn = %s\n", hostn);

  if (*cin != ' ')
    return(3);

  /* read in tag */

  cin++;
  i = 0;
  for (cout = tag; *cin != '/' && *cin != ' ' && *cin != '\n' && *cin != '\0' && i < MAXSTRINGLENGTH - 1;
       cin++) {
   *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
if(debug)
	fprintf(stderr, "tag = %s\n", tag);

  if (*cin != '/')
    return(4);
  if(strstr(tag, "ICP_") != NULL) {
        tag[0] = 'U';
        tag[1] = 'D';
        tag[2] = 'P';
  }

  /* read in code */
  cin++;
  if(*cin == '0') {
	*code = 0;
  }
  else {
  if (!isdigit(*cin))
    if (*cin == '-' && *(cin + 1) == ' ')
      *code = 299;
    else
      return(5);
  else {
    *code = 100 * (*cin - '0');
    cin++;
    if (!isdigit(*cin))
      return(6);
    else
      *code += 10 * (*cin - '0');
    cin++;
    if (!isdigit(*cin))
      return(7);
    else
      *code += (*cin - '0');
  }
  }
if(debug)
	fprintf(stderr, "code : %d\n", *code);

  /* read in bytestr */
  cin++;
  while (*cin != ' ') {
        cin++;
  }
  if (*cin != ' ')
    return (8);
  cin++;
  i = 0;
  for (cout = bytestr; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 15;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
  if (*cin != ' ') 
    return(9);

if(debug)
	fprintf(stderr, "bytestr : %s\n", bytestr);


  /* read in method */
  cin++;
  i = 0;
  for (cout = method; *cin != ' ' && *cin != '\n' && *cin != '\0' && i < 14;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
  if (*cin != ' ') 
    return(10);
if(debug)
	fprintf(stderr, "method : %s\n", method);

  /* read in url */
  cin++;
  i = 0;
  for (cout = url; *cin != ' ' && *cin != '\0' && i < MAXURL - 1;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
  if (*cin != ' ')
    return(11);

if(debug)
	fprintf(stderr, "url : %s\n", url);

fflush(stderr);
  parse_url(url, protocole, remote_host, &port, path);
if(debug)
	fprintf(stderr, "protocole : %s, remote_host : %s, port: %d, path : %s\n", protocole, remote_host, port, path);
  scan_url(path, filetype);
if(debug)
	fprintf(stderr, "filetype : %s\n", filetype);
  sprintf(rhost, "%s", remote_host);
if(debug)
	fprintf(stderr, "rhost : %s\n", rhost);
  
  /* read in the end */
  cin++;
  i = 0;
  while(*cin != ' ' && *cin != '\0' && i < MAXSTRINGLENGTH - 1) {
	 cin++;
  }
  if (*cin != ' ')
    return(12);
  
  cin++;
  i = 0;
  for (cout = tag2; *cin != '/' && *cin != ' ' && *cin != '\0' && i < MAXSTRINGLENGTH - 1;
  	cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
  
  if (*cin != '/')
    return(13);
if(debug)
        fprintf(stderr, "tag2 : %s\n", tag2);
  
  /* read in neighbour name */
  cin++;
  i = 0;
  for (cout = neighbour; *cin != ' ' && *cin != '\0' && i < MAXSTRINGLENGTH - 1;
       cin++) {
    *cout = *cin;
    cout++;
    i++;
  }
  *cout = '\0';
  if (*cin != ' ') 
    return(14);
if(debug)
        fprintf(stderr, "neighbour : %s\n", neighbour);
  
  return(0);

}


int sscanf_domains(char *inputline, char string1[MAXSTRINGLENGTH],
		   char string2[MAXSTRINGLENGTH])
{   /* scanning the domains file */
  register char *cin = inputline;
  register char *cout;
  int i;

  /* run past any white space */
  while (*cin == ' ' || *cin == '\t')
    cin++;

  /* if no strings on this line, return 0 */
  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(0);

  /* otherwise fill up string 1; coerce domains to lower case */
  i = 0;
  for (cout = string1; *cin != ' ' && *cin != '\t' && *cin != '#' &&
       *cin != '\0' && *cin != '\n' && i < MAXSTRINGLENGTH - 1; cin++) {
    *cout = tolower(*cin);
    cout++;
    i++;
  }

  /* is that the end of the line (maybe after some white space)? */
  if (*cin == '#' || *cin == '\0' || *cin == '\n' || i == MAXSTRINGLENGTH - 1)
    return(1);

  *cout = '\0';
  cin++;

  while (*cin == ' ' || *cin == '\t')
    cin++;

  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(1);

  /* otherwise fill up string 2 */
  for (cout = string2; *cin != '#' && *cin != '\n' && *cin != '\0' &&
       i < MAXSTRINGLENGTH - 1; cin++) {
    *cout = *cin;
    cout++;
    i++;
  }

  *cout = '\0';
  return(2);

}

int sscanf_types(char *inputline, char string1[MAXSTRINGLENGTH],
                   char string2[MAXSTRINGLENGTH])
{   /* scanning the domains file */
  register char *cin = inputline;
  register char *cout;
  int i;

  /* run past any white space */
  while (*cin == ' ' || *cin == '\t')
    cin++;

  /* if no strings on this line, return 0 */
  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(0);

  /* otherwise fill up string 1; coerce domains to lower case */
  i = 0;
  for (cout = string1; *cin != ' ' && *cin != '\t' && *cin != '#' &&
       *cin != '\0' && *cin != '\n' && i < MAXSTRINGLENGTH - 1; cin++) {
    *cout = tolower(*cin);
    cout++;
    i++;
  }

  /* is that the end of the line (maybe after some white space)? */
  if (*cin == '#' || *cin == '\0' || *cin == '\n' || i == MAXSTRINGLENGTH - 1)
    return(1);

  *cout = '\0';
  cin++;

  while (*cin == ' ' || *cin == '\t')
    cin++;

  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(1);

  /* otherwise fill up string 2 */
  for (cout = string2; *cin != '#' && *cin != '\n' && *cin != '\0' &&
       i < MAXSTRINGLENGTH - 1; cin++) {
    *cout = *cin;
    cout++;
    i++;
  }

  *cout = '\0';
  return(2);

}



int sscanf_config(char *inputline, char string1[MAXSTRINGLENGTH],
		  char string2[MAXSTRINGLENGTH],
		  char string3[MAXSTRINGLENGTH])
{   /* scanning the domains file */
  register char *cin = inputline;
  register char *cout;
  int i;

  /* run past any white space */
  while (*cin == ' ' || *cin == '\t')
    cin++;

  /* if no strings on this line, return 0 */
  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(0);

  /* otherwise fill up string 1; convert arguments to upper case */
  i = 0;
  for (cout = string1; *cin != ' ' && *cin != '\t' && *cin != '#' &&
       *cin != '\0' && *cin != '\n' && i < MAXSTRINGLENGTH - 1; cin++) {
    *cout = *cin;
    cout++;
    i++;
  }

  *cout = '\0';

  /* is that the end of the line (maybe after some white space)? */
  if (*cin == '#' || *cin == '\0' || *cin == '\n' || i == MAXSTRINGLENGTH - 1)
    return(1);

  cin++;

  while (*cin == ' ' || *cin == '\t')
    cin++;

  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(1);

  /* if string 2 starts with a quote mark, fill up until the next quote
     mark. Otherwise, just fill until the next space */

  if (*cin == '\'') {
    cin++;
    for (cout = string2; *cin != '\n' && *cin != '\0' && *cin != '\'' &&
	 i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }
  else if (*cin == '"') {
    cin++;
    for (cout = string2; *cin != '\n' && *cin != '\0' && *cin != '"' &&
	 i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }
  else {
    for (cout = string2; *cin != '#' && *cin != '\n' && *cin != '\0' &&
	 *cin != ' ' && *cin != '\t' && i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }

  *cout = '\0';

  /* is that the end of the line (maybe after some white space)? */
  if (*cin == '#' || *cin == '\0' || *cin == '\n' || i == MAXSTRINGLENGTH - 1)
    return(2);

  cin++;

  while (*cin == ' ' || *cin == '\t')
    cin++;

  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(2);

  /* otherwise fill up string 3 */
  if (*cin == '\'') {
    cin++;
    for (cout = string3; *cin != '\n' && *cin != '\0' && *cin != '\'' &&
	 i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }
  else if (*cin == '"') {
    cin++;
    for (cout = string3; *cin != '\n' && *cin != '\0' && *cin != '"' &&
	 i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }
  else {
    for (cout = string3; *cin != '#' && *cin != '\n' && *cin != '\0' &&
	 *cin != ' ' && *cin != '\t' && i < MAXSTRINGLENGTH - 1; cin++) {
      *cout = *cin;
      cout++;
      i++;
    }
  }

  *cout = '\0';

  /* is that the end of the line (maybe after some white space)? */
  if (*cin == '#' || *cin == '\0' || *cin == '\n' || i == MAXSTRINGLENGTH - 1)
    return(3);

  cin++;

  while (*cin == ' ' || *cin == '\t')
    cin++;

  if (*cin == '#' || *cin == '\n' || *cin == '\0')
    return(3);

  return(4);   /* we don't ever want to read a fourth string; just know if
		  there is one for error checking */

}
